// @ts-ignore
import type { Context, IntegrationsConfig } from 'https://edge.netlify.com';

const FILES = ['index', 'metadata', 'stories'];
const VERSION = '1.4.1'; // x-release-please-version

export default async (
  request: Request,
  { next }: Context,
): Promise<Response> => {
  const response = (await next()) as Response;
  const origin = request.headers.get('Origin');

  if (origin) {
    response.headers.set('Access-Control-Allow-Origin', origin);
    response.headers.set('Access-Control-Allow-Credentials', 'true');
  }

  return response;
};

export const config: IntegrationsConfig = {
  name: 'Set Storybook headers',
  generator: ['@netlify/plugin-storybook', VERSION].join('@'),
  path: FILES.map((file) => `/${file}.json`),
};
